---
title: IDBDatabase.onversionchange
slug: Web/API/IDBDatabase/onversionchange
tags:
  - API
  - Database
  - IDBDatabase
  - IndexedDB
  - Property
  - Reference
  - Storage
  - onversionchange
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>onversionchange</code></strong> event handler of the {{domxref("IDBDatabase")}} interface handles the versionchange event, fired when a database structure change ({{ domxref("IDBOpenDBRequest.onupgradeneeded")}} event or {{ domxref("IDBFactory.deleteDatabase")}}) was requested elsewhere (most probably in another window/tab on the same computer).</p>

<p>This is different from the <code>versionchange</code> transaction (but it is related).</p>

<p>{{AvailableInWorkers}}</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox" style="font-size: 14px;"><em>IDBDatabase</em>.onversionchange = <em>function</em>(event) { ... }</pre>

<h2 id="Example">Example</h2>

<p>This example shows an {{domxref("IDBOpenDBRequest.onupgradeneeded")}} block that creates a new object store; it also includes <code style="font-style: normal;">onerror</code> and <code style="font-style: normal;">onabort</code> functions to handle non-success cases, and an onversionchange function to notify when a database structure change has occurred.</p>

<pre class="brush: js;highlight:[28,29,30,31,32]">request.onupgradeneeded = function(event) {
  var db = event.target.result;

  db.onerror = function(event) {
    note.innerHTML += '&lt;li&gt;Error opening database.&lt;/li&gt;';
  };

  db.onabort = function(event) {
    note.innerHTML += '&lt;li&gt;Database opening aborted!&lt;/li&gt;';
  };

  // Create an objectStore for this database

  var objectStore = db.createObjectStore("toDoList", { keyPath: "taskTitle" });

  // define what data items the objectStore will contain

  objectStore.createIndex("hours", "hours", { unique: false });
  objectStore.createIndex("minutes", "minutes", { unique: false });
  objectStore.createIndex("day", "day", { unique: false });
  objectStore.createIndex("month", "month", { unique: false });
  objectStore.createIndex("year", "year", { unique: false });

  objectStore.createIndex("notified", "notified", { unique: false });

  note.innerHTML += '&lt;li&gt;Object store created.&lt;/li&gt;';

  db.onversionchange = function(event) {
    note.innerHTML += '&lt;li&gt;a database change has occurred; you should refresh this
                       browser window, or close it down and use the other open version of
                       this application, wherever it exists.&lt;/li&gt;';
  };
};</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB', '#dom-idbdatabase-onversionchange', 'onversionchange')}}</td>
   <td>{{Spec2('IndexedDB')}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbdatabase-onversionchange", "onversionchange")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBDatabase.onversionchange")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
 <li><code><a href="/en-US/docs/Web/API/IDBDatabase/versionchange_event">versionchange</a></code> event</li>
</ul>
